
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "xstd/String.h"
#include "base/polyVersion.h"

// sync this and remake executables whenever release name changes!
#define POLY_VERSION_STR "2.8.0"

// for use with ident-like scanners
static String PolyVerIdentStr = 
	"@(#) $Polygraph: " POLY_VERSION_STR " $";

static String PolyCompTimestampIdentStr = 
	"@(#) $CompilationTimestamp: " __DATE__ " " __TIME__ " $";


const String &PolyVersion() {
	Assert(PolyVerIdentStr); // just to use it somewhere
	Assert(PolyCompTimestampIdentStr); // just to use it somewhere
	static String vs = POLY_VERSION_STR;
	return vs;
}

const String &PolyCompDate() {
	static String ds = __DATE__;
	return ds;
}

const String &PolyCompTime() {
	static String ts = __TIME__;
	return ts;
}

const String &PolyLetterhd() {
	static String lh =
		"Polygraph " POLY_VERSION_STR
		"        Copyright (C) 1998-2001.\n"
		"Distributed without any warranty, even implied. \n"
		"See  http://www.web-polygraph.org/ for details.";
	return lh;
}
