
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_FOREIGN_WORLD_CLASS_H
#define PG_FOREIGN_WORLD_CLASS_H

#include "xstd/String.h"
#include "xstd/Array.h"
#include "runtime/ObjWorld.h"

// an iterator over a trace of foreign URLs
// preloads the trace in RAM at configure time
class ForeignWorld: public ObjWorld {
	public:
		static int TheWss; // all local foreign worlds

	public:
		ForeignWorld();

		void configure(const String &aName, istream &aStream);

		bool canProduce() const;

		void repeat(ObjId &oid, ObjSelector *sel);
		void produce(ObjId &oid, RndGen &rng);

	protected:
		String theName;
		Array<String*> theUrls;
};

#endif
