
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "client/PrivWorld.h"


int PrivWorld::TheFrozenCount = 0;
int PrivWorld::TheTotalCount = 0;
int PrivWorld::TheWss = 0;

bool PrivWorld::Frozen() {
	return TheFrozenCount == TheTotalCount;
}

PrivWorld::PrivWorld(const UniqId &anId) {
	id(anId);
}

void PrivWorld::produce(ObjId &oid, RndGen &rng) {
	ObjWorld::produce(oid, rng);
	incWss(TheWss);
}

void PrivWorld::freezeWss() {
	if (wss() < 0) { // not yet frozen
		ObjWorld::freezeWss();
		TheFrozenCount++;
	}
}
