
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_CLIENT_PRIVATE_WORLDS_H
#define PG_CLIENT_PRIVATE_WORLDS_H

class HostCfg;
class NetAddr;
class PrivWorld;
class Client;

// iterates over client's private worlds (of visible servers)
class PrivWorldIterator {
	public:
		PrivWorldIterator(Client *aClient);

		int count() const;
		bool atEnd() const;

		int viserv() const;
		HostCfg *host() const;
		const NetAddr &addr() const;
		PrivWorld &privWorld() const;

		PrivWorldIterator &operator ++();
		void next();
	
	protected:
		void sync();

	protected:
		Client *theClient;
		int theIdx;
};

#endif
