
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "base/OLog.h"
#include "base/ILog.h"
#include "runtime/httpHdrs.h"
#include "client/ServerRep.h"


ServerRep::ServerRep(const NetAddr &anAddr, int aHostIdx): 
	theAddr(anAddr), theHostIdx(aHostIdx), theSrvIdx(-1),
	theAccCount(0) {
}

void ServerRep::syncSrvInfo(const RepHdr &) {
	theAccCount++;
}

void ServerRep::store(OLog &log) const {
	log
		<< theAddr
		<< theAccCount
		;
}

void ServerRep::load(ILog &log) {
	log
		>> theAddr
		>> theAccCount
		;
}
