
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_REPORT_BLOB_H
#define PG_REPORT_BLOB_H

#include "xstd/String.h"
#include "xml/XmlTag.h"

// an XML container with a key or name
// a labeled "box" so others to find its contents
class ReportBlob: public XmlTag {
	public:
		typedef String Key;

	public:
		ReportBlob(const Key &aKey);
		ReportBlob(const ReportBlob &b);
		virtual ~ReportBlob();

		virtual XmlNode *clone() const;

		const Key &key() const { return theKey; }

	protected:
		Key theKey;
};

#endif
