
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_RESPONSE_TIME_TRACE_FIGURE_H
#define PG_RESPONSE_TIME_TRACE_FIGURE_H

#include "xstd/String.h"
#include "loganalyzers/ReportTraceFigure.h"

class Stex;
class PhaseInfo;
class PhaseTrace;
class StatIntvlRec;

// creates response time distribution figure based on phase stats
class RptmTraceFig: public ReportTraceFigure {
	public:
		RptmTraceFig();

		void stats(const Stex *aStex, const PhaseInfo *phase);
		void moreStats(const Stex *aStex);

	protected:
		virtual int createCtrlFile();
		virtual void setCtrlOptions();
		int dumpDataLines(const Stex *stex);
		int dumpDataLine(const Stex *stex, Time stamp, const StatIntvlRec &r);
		
	protected:
		Array<const Stex*> theStexes;
		const PhaseInfo *thePhase;
		const PhaseTrace *theTrace;
};

#endif
