
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_PGL_EVERY_CODE_SYMBOL_H
#define PG_PGL_EVERY_CODE_SYMBOL_H

#include "pgl/PglExprSym.h"

class GoalSym;
class CodeSym;

// conditional code; used by phase watchdogs
class EveryCodeSym: public ExpressionSym {
	public:
		static String TheType;

	public:
		EveryCodeSym();
		EveryCodeSym(const GoalSym &aGoal, const CodeSym &aCode);
		EveryCodeSym(GoalSym *aGoal, CodeSym *aCode);
		virtual ~EveryCodeSym();

		const GoalSym *goal() const;
		const CodeSym *call() const;

		virtual bool isA(const String &type) const;

		virtual ostream &print(ostream &os, const String &pfx) const;

	protected:
		virtual SynSym *dupe(const String &dType) const;

	protected:
		GoalSym *theGoal;
		CodeSym *theCode;
};

#endif
