
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PGL_MEMBERSHIP_MAP_H
#define PGL_MEMBERSHIP_MAP_H

#include "pgl/PglRecSym.h"

class RndDistr;
class StringArray;

// parameters for object life cycle model
class MembershipMapSym: public RecSym {
	public:
		static const String TheType;

	public:
		MembershipMapSym();
		MembershipMapSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;

		bool groupSpace(StringArray &names) const;
		bool memberSpace(StringArray &names) const;
		RndDistr *groupsPerMember() const;

	protected:
		virtual SynSym *dupe(const String &dType) const;
};

#endif
