
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PGL_CLONER_H
#define PGL_CLONER_H

#include "pgl/PglContainerSym.h"

// a compact representation of N cloned items
class ClonerSym: public ContainerSym {
	public:
		static String TheType;

	public:
		ClonerSym(const SynSym &aSource, int aCount);
		virtual ~ClonerSym();

		virtual bool isA(const String &type) const;

		virtual int count() const;
		virtual bool probsSet() const;
		virtual const SynSym *itemProb(int offset, double &prob) const;

		virtual void toStringArray(StringArray &strs) const;

		virtual ostream &print(ostream &os, const String &pfx) const;

	protected:
		virtual SynSym *dupe(const String &type) const;

	protected:
		SynSym *theSource;
		int theCount;
};

#endif
