
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PGL_NUM_EXPRESSION_SYMBOL_H
#define PGL_NUM_EXPRESSION_SYMBOL_H

#include "pgl/PglExprSym.h"

// floating point "number"

class NumSym: public ExpressionSym {
	public:
		static const String TheType;

	public:
		NumSym(double aVal);

		double val() const { return theVal; }
		void val(double v) { theVal = v; }

		virtual bool isA(const String &type) const;

		virtual ExpressionSym *unOper(const Oper &op) const;
		virtual ExpressionSym *bnOper(const Oper &op, const SynSym &exp) const;

		virtual ostream &print(ostream &os, const String &pfx) const;

	protected:
		virtual SynSym *dupe(const String &dType) const;

	protected:
		double theVal;
};

#endif
