
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "pgl/pgl.h"

#include "xstd/String.h"
#include "pgl/PglIntSym.h"
#include "pgl/PglRec.h"
#include "pgl/RLimitsSym.h"



String RLimitsSym::TheType = "RLimits";

static String strFds = "fds";


RLimitsSym::RLimitsSym(): RecSym(TheType, new PglRec) {
	theRec->bAdd(IntSym::TheType, strFds, 0);
}

RLimitsSym::RLimitsSym(const String &aType, PglRec *aRec): RecSym(aType, aRec) {
	// find fields
}

bool RLimitsSym::isA(const String &type) const {
	return RecSym::isA(type) || type == TheType;
}

SynSym *RLimitsSym::dupe(const String &type) const {
	if (isA(type))
		return new RLimitsSym(this->type(), theRec->clone());
	return RecSym::dupe(type);
}
