
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_RUNTIME_SCRIPT_H
#define PG_RUNTIME_SCRIPT_H

#include "pgl/PglSemx.h"

class SynSym;
class StatIntvl;
class DutWatchdog;

// run-time in-core PGL interpreter
class Script: public PglSemx {
	public:
		typedef DutWatchdog Sampler;

	public:
		Script(const SynSym &aCode);
		virtual ~Script();
		
		void statsSampler(Sampler *aSampler);

		const SynSym &code() const;

		void run();

		ExpressionSym *callFunc(const String &cname, const ListSym &args);
		virtual void callProc(const String &cname, const ListSym &args);
		virtual void execEveryCode(const EveryCodeSym &ecode);

	protected:
		SynSym *theCode;
		Sampler *theSampler;
};

#endif
