
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_RUNTIME_SESSION_WATCH_H
#define PG_RUNTIME_SESSION_WATCH_H

#include "xstd/String.h"

// common interface for watching over Agent session changes
template <class Agent>
class SessionWatch {
	public:
		virtual ~SessionWatch() {}

		virtual String id() const = 0; // name-dash-version
		virtual void describe(ostream &os) const = 0; // a brief description

		virtual void noteStart(const Agent *a) = 0;    // called when session starts
		virtual void noteHeartbeat(const Agent *a) = 0; // session heartbeat
		virtual void noteEnd(const Agent *a) = 0;      // called when session ends
};

#endif
