
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "xml/XmlText.h"
#include "xml/XmlTag.h"
#include "xml/XmlRenderer.h"

void XmlRenderer::renderNode(const XmlNode &node) {
	if (node.kids()) {
		renderTag((const XmlTag&)node);
	} else {
		const String text = ((const XmlText &)node).text();
		renderText(text.cstr(), text.len());
	}
}

void XmlRenderer::renderTag(const XmlTag &tag) {
	foreach(tag.kids());
}

void XmlRenderer::foreach(const XmlNodes *nodes) {
	if (nodes) {
		for (int i = 0; i < nodes->count(); ++i)
			nodes->item(i)->render(*this);
	}
}
