
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_XML_TAG_NODE_H
#define PG_XML_TAG_NODE_H

#include "xstd/String.h"
#include "xml/XmlNodes.h"
#include "xml/XmlAttrs.h"
#include "xml/XmlNode.h"

// an XML <tag> node 
// may have attributes and kids
// never has "text"
class XmlTag: public XmlNode {
	public:
		XmlTag(const String &aName);
		XmlTag(const XmlTag &aTag);
		virtual ~XmlTag();

		virtual XmlNode *clone() const;

		virtual const String &name() const { return theName; }

		virtual XmlAttrs *attrs() { return &theAttrs; }
		virtual const XmlAttrs *attrs() const { return &theAttrs; }
		virtual const XmlNodes *kids() const { return &theKids; }

		XmlAttr *append(const XmlAttr &a);
		XmlNode *append(const XmlNode &n);

		XmlTag &operator <<(const XmlAttr &a);
		XmlTag &operator <<(const XmlNode &n);
		XmlTag &operator <<(const XmlNodes &ns);

		virtual ostream &print(ostream &os, const String &pfx) const;
		virtual void render(XmlRenderer &r) const;

		void printOpen(ostream &os, const String &pfx) const;

	protected:
		virtual XmlNodes *kids2() { return &theKids; }

	protected:
		String theName;
		XmlAttrs theAttrs;
		XmlNodes theKids;
};

#endif
